added 'plain' parameter to output plain text without markup
[bash-notes.git] / notes.sh
1 #! /bin/bash
2
3 # set -ex
4
5 PID=$$
6 VERSION="0.1"
7
8 set_defaults() {
9 # Binaries to use
10 EDITOR=${EDITOR:-/usr/bin/vim}
11 TERMINAL=${TERMINAL:-/usr/bin/alacritty}
12 JQ=${JQ:-/usr/bin/jq}
13
14 # base directory for program files
15 BASEDIR=${BASEDIR:-~/.local/share/bash-notes}
16 # notes database in json format
17 DB=${BASEDIR}/db.json
18 # directory containing the actual notes
19 NOTESDIR=${BASEDIR}/notes
20
21 } # end set_defaults, do not change this line.
22
23 set_defaults
24
25 # Do not edit below this point
26 RCFILE=${RCFILE:-~/.config/bash-notes.rc}
27 TMPDB=/tmp/db.json
28 BASENAME=$( basename $0 )
29 NOW=$(date +%s)
30
31 if [ ! -x $JQ ]; then
32 echo "jq not found in your PATH"
33 echo "install jq to continue"
34 exit 1
35 fi
36
37 # IMPORT USER DEFINED OPTIONS IF ANY
38 if [[ -f $RCFILE ]]; then
39 source $RCFILE
40 fi
41
42 # We prevent the program from running more than one instance:
43 PIDFILE=/var/tmp/$(basename $0 .sh).pid
44
45 # Make sure the PID file is removed when we kill the process
46 trap 'rm -f $PIDFILE; exit 1' TERM INT
47
48 if [[ -r $PIDFILE ]]; then
49 # PIDFILE exists, so I guess there's already an instance running
50 # let's kill it and run again
51 kill -s 15 $(cat $PIDFILE) > /dev/null 2>&1
52 # should already be deleted by trap, but just to be sure
53 rm $PIDFILE
54 fi
55
56 # create PIDFILE
57 echo $PID > $PIDFILE
58
59 function helptext() {
60 echo "Usage:"
61 echo " $0 [PARAMS] ..."
62 echo ""
63 cat << __NOWCONF__
64 ${BASENAME} configuration is:
65
66 base directory: ${BASEDIR}/
67 notes archive: ${NOTESDIR}/
68 notes database: ${DB}
69 rc file: $RCFILE
70
71 text editor: ${EDITOR}
72 terminal: ${TERMINAL}
73 jq executable: ${JQ}
74 __NOWCONF__
75
76 echo ""
77 echo "The script's parameters are:"
78 echo " -h | --help : This help text"
79 echo " -p | --plain : Output is in plain text"
80 echo " (without this option the output is colored)"
81 echo " -l | --list : List existing notes"
82 echo " -a | --add <title> : Add new note"
83 echo " -m | --modify <note> : Modify note"
84 echo " -d | -date <note> : Modify date for note"
85 echo " -r | --remove <note> : Remove note"
86 echo " -v | --version : Print version"
87 echo " --userconf : Export User config file"
88 }
89
90 function addnote() {
91 NOTETITLE="$1"
92 echo "adding new note - \"$NOTETITLE\""
93 LASTID=$($JQ '.notes[-1].id | tonumber' $DB)
94 [ null == $LASTID ] && LASTID=0
95 NOTEID=$(( $LASTID + 1 ))
96 touch ${NOTESDIR}/${NOW}
97 $JQ --arg i "$NOTEID" --arg t "$NOTETITLE" --arg f "$NOW" '.notes += [{"id": $i, "title": $t, "file": $f}]' "$DB" > $TMPDB
98 mv $TMPDB $DB
99 $(${TERMINAL} --class notes --title notes -e ${EDITOR} ${NOTESDIR}/${NOW})
100 }
101
102 function listnotes() {
103 echo "listing all notes"
104 [ $PLAIN == true ] && echo "output is plain text" || echo "output is colored"
105 echo ""
106 echo "[ID] [TITLE]"
107 for i in ${NOTESDIR}/*; do
108 TITLE=$($JQ -r --arg z $(basename $i) '.notes[] | select(.file == $z) | .title' $DB)
109 ID=$($JQ -r --arg z $(basename $i) '.notes[] | select(.file == $z) | .id' $DB)
110
111 echo "[${ID}] ${TITLE}"
112 done
113 }
114
115 function editnote() {
116 TITLE=$($JQ --arg i $1 '.notes[] | select(.id == $i) | .title' $DB)
117 FILE=$($JQ -r --arg i $1 '.notes[] | select(.id == $i) | .file' $DB)
118 if [ "$TITLE" ]; then
119 echo "editing note $TITLE"
120 $(${TERMINAL} --class notes --title notes -e ${EDITOR} ${NOTESDIR}/${FILE})
121 else
122 echo "note not found"
123 exit 1
124 fi
125 }
126
127 function datenote() {
128 echo "edit date for note \"${1}\""
129 # FILEDATE=$(date -d @$NOW +%d/%m/%Y_%T)
130
131 }
132
133 function rmnote() {
134 NOTE=$1
135 echo "removing note $NOTE"
136 }
137
138 function export_config() {
139 if [ -r ${RCFILE} ]; then
140 echo "Backing up current '${RCFILE}'...."
141 mv -f ${RCFILE} ${RCFILE}.$(date +%Y%m%d_%H%M)
142 fi
143 echo "Writing '${RCFILE}'...."
144 sed -n '/^set_defaults() {/,/^} # end set_defaults, do not change this line./p' $0 \
145 | grep -v set_defaults \
146 | sed -e 's/^\([^=]*\)=\${\1:-\([^}]*\)}/\1=\2/' \
147 > ${RCFILE}
148 if [ -r ${RCFILE} ]; then
149 echo "Taking no further action."
150 exit 0
151 else
152 echo "Could not write '${RCFILE}'...!"
153 exit 1
154 fi
155 }
156
157 # we should expand on this function to add a sample note and explain a little bit
158 # how the program works.
159 function firstrun() {
160 [ -f $RCFILE ] && RC=$RCFILE || RC="none"
161
162 clear
163 echo "${BASENAME} configuration:
164
165 base directory: ${BASEDIR}/
166 notes archive: ${NOTESDIR}/
167 notes database: ${DB}
168 rc file: $RC
169 text editor: ${EDITOR}
170 terminal: ${TERMINAL}
171 jq executable: ${JQ}
172 "
173
174 read -r -p "Do you wish to continue? (y/N) " ANSWER
175 case $ANSWER in
176 y|Y )
177 mkdir -p $NOTESDIR
178 cat << __EOL__ > ${DB}
179 {
180 "params": {
181 "version": "${VERSION}",
182 "dbversion": "${NOW}"
183 },
184 "notes": []
185 }
186 __EOL__
187 echo; echo "All done, you can now write your first note."
188 ;;
189 * )
190 echo "No changes made. Exiting"
191 exit
192 ;;
193 esac
194 }
195
196 # check for notes dir existance and create it in case it doesn't exists
197 if [[ ! -d $NOTESDIR ]]; then
198 # we don't have a directory. FIRST RUN?
199 firstrun
200 fi
201
202 # NOTE: This requires GNU getopt. On Mac OS X and FreeBSD, you have to install this
203 # separately; see below.
204 GOPT=`getopt -o hvpla:m:d:r: --long help,version,list,plain,userconf,add:,modify:,date:,remove:,editor:,storage: \
205 -n 'bash-notes' -- "$@"`
206
207 if [ $? != 0 ] ; then echo "Terminating..." >&2 ; exit 1 ; fi
208
209 # Note the quotes around `$GOPT': they are essential!
210 eval set -- "$GOPT"
211
212 PLAIN=false
213
214 while true; do
215 case "$1" in
216 -h | --help )
217 helptext
218 exit
219 ;;
220 -v | --version )
221 echo $BASENAME v${VERSION}
222 exit
223 ;;
224 -p | --plain )
225 PLAIN=true
226 shift
227 ;;
228 -l | --list )
229 listnotes
230 exit
231 ;;
232 -a | --add )
233 TITLE="$2"
234 shift 2
235 addnote "$TITLE"
236 ;;
237 -m | --modify )
238 NOTE="$2"
239 shift 2
240 editnote "$NOTE"
241 ;;
242 -d | --date )
243 NOTE="$2"
244 shift 2
245 datenote "$NOTE"
246 ;;
247 -r | --remove )
248 NOTE="$2"
249 shift 2
250 rmnote "$NOTE"
251 ;;
252 --userconf )
253 export_config
254 echo "config exported to \"$RCFILE\""
255 exit
256 ;;
257 -- )
258 shift; break
259 ;;
260 * )
261 break
262 ;;
263 esac
264 done
265